#ifndef COLUMNBUFFERARRAY_H_
#define COLUMNBUFFERARRAY_H_

#include "ClockedBufferArray.h"

namespace YARC {

class ColumnBufferArray: public ClockedBufferArray {
protected:
    
    virtual void initialize();
    virtual void handleMessage(cMessage *msg);
    
    virtual bool canSendHeadFlit(HeadFlit *head);  
    virtual bool canSendFlit(Flit*);
    virtual bool canSendTailFlit(TailFlit *tail); 
    
private:
    
    cGate *throttle;
    
    char isCongested[2];
    
    bool canSend();
};

}

#endif /* COLUMNBUFFERARRAY_H_ */
