#ifndef DFLIPFLOP_H_
#define DFLIPFLOP_H_

#include <omnetpp.h>
#include <cgate.h>
#include <simtime.h>

namespace YARC {

class DFlipFlop: public cSimpleModule {
public:
    
    DFlipFlop();

protected:
    
    virtual void initialize();
    virtual void handleMessage(cMessage *msg);

private:
    
    cGate *in;
    cGate *out;
    
    bool strict;
    
    simtime_t clockPeriod;
    simtime_t lastClockT;
};

}

#endif /* DFLIPFLOP_H_ */
