#ifndef ROUTINGLOGIC_H_
#define ROUTINGLOGIC_H_

#include <omnetpp.h>
#include <cgate.h>

namespace YARC {

class RoutingLogic: public cSimpleModule {
protected:
    
    virtual void initialize();
    virtual void handleMessage(cMessage *msg);
    
private:
    
    cGate *in;
    cGate *out;
    cGate *ack;
    cGate *throttle;
    
    int colCount;
    const char *routingParams;
    
    char (*isCongested)[2];
    int currentDstPort;
    int currentVC;
    bool pendingAckEmit;
    
    int switchId;
};

}

#endif /* ROUTINGLOGIC_H_ */
