#ifndef ROWBUFFERARRAY_H_
#define ROWBUFFERARRAY_H_

#include <omnetpp.h>
#include <cgate.h>

#include "ClockedBufferArray.h"
#include "Messages_m.h"

namespace YARC {

class RowBufferArray: public ClockedBufferArray {
protected:
    
    virtual void initialize();
    virtual void handleMessage(cMessage *msg);
    
    virtual bool canSendHeadFlit(HeadFlit *head);  
    virtual bool canSendFlit(Flit*);
    virtual bool canSendTailFlit(TailFlit *tail);
    
private:
    
    cGate *throttle;
    
    char (*colBufferCongested)[2];
    
    int currentOutputRow;
};

}

#endif /* ROWBUFFERARRAY_H_ */
