#ifndef SIDEBANDADDER_H_
#define SIDEBANDADDER_H_

#include <omnetpp.h>
#include <cgate.h>

#include "Messages_m.h"

namespace YARC {

class SidebandAdder: public cSimpleModule {
protected:
    
    virtual void initialize();
    virtual void handleMessage(cMessage *msg);
  
private:
    
    cGate *in;
    cGate *out;
    cGate *sidebandIn;
    
    simtime_t clockStart;
    simtime_t clockPeriod;
    
    char sideband[2];
    
    simtime_t lastSbdUpdate;
    simtime_t lastSentFlit;
    
    Flit *newFlit;
};

}

#endif /* SIDEBANDADDER_H_ */
